<?php

/**
 * This class holds important DataBase methods.
 *
 * @author Beldur
 **/
class DataBase
{
	private $strHostname;
	private $strUsername;
	private $strPassword;
	private $strDataBase;

	private $objErrorHandler;

	private $bConnected;
	private $nQueryCounter;

	public function DataBase($theHostname, $theUsername, $thePassword, $theDatabase, $theErrorHandler)
	{
		$this->bConnected = false;
		$this->nQueryCounter = 0;
		$this->strHostname = $theHostname;
		$this->strUsername = $theUsername;
		$this->strPassword = $thePassword;
		$this->strDataBase = $theDatabase;
		$this->objErrorHandler = $theErrorHandler;
	}

	/**
	 * This method connects to the MySQL database.
	 *
	 * @return True if the connection has been established.
	 **/
	public function Connect()
	{
		if(mysql_connect($this->strHostname, $this->strUsername, $this->strPassword))
		{
			if(mysql_select_db($this->strDataBase))
			{
				$this->bConnected = true;
				return true;
			}
			else
			{
				$this->objErrorHandler->ShowError("Could not select Database: " . mysql_error());
			}
		}
		else
		{
			$this->objErrorHandler->ShowError("Could not connect to Database: " . mysql_error());
		}
	}

	public function IsConnected()
	{
		return $this->bConnected;
	}

	public function SQLQueries()
	{
		return $this->nQueryCounter;
	}

	/**
	 * This methods send a SQL query to the database.
	 *
	 * @param string $theQuery
	 * @return The query result from the Database.
	 **/
	public function Query($theQuery)
	{
		$queryResult = mysql_query($theQuery);
		if($queryResult)
		{
			$this->nQueryCounter++;
			return $queryResult;
		}
		else
		{
			$this->objErrorHandler->ShowError("Error in Query: " . mysql_error() . "<br>Query: " . $theQuery);
		}
	}

	/**
	 * This method returns all instances.
	 *
	 * @return An array with all instances.
	 **/
	public function GetInstances()
	{
		$arrInstances = array();
		$i = 0;

		$instances = $this->Query("SELECT ID, InstanceName FROM tblinstances ORDER BY tblinstances.ID");
		while(($objInstance = mysql_fetch_object($instances)) == true)
		{
			$arrInstances[$i] = $objInstance;
			$i++;
		}

		return $arrInstances;
	}

	/**
	 * This Method return an Array witch all Raids ordered by the number of kills the Raids has.
	 *
	 * @param mixed $theFaction Can be H for Horde and A for Alliance
	 * @return An array with all riads.
	 **/
	public function GetRaids($theFaction = NULL)
	{
		$strFactionClausel = "";
		$arrRaids = array();
		$i = 0;

		if($theFaction == "A" or $theFaction == "H")
		{
			$strFactionClausel = "AND tblraids.Faction = '" . $theFaction . "'";
		}

		$raids = $this->Query("SELECT tblraids.ID, tblraids.RaidName, tblraids.RaidTag, tblraids.RaidHomepage, COUNT(tblkills.RaidID) AS NumberOfKills
								FROM tblkills, tblraids
								WHERE (tblkills.RaidID = tblraids.ID)
									" . $strFactionClausel . "
								GROUP BY tblkills.RaidID
								");

		while(($objRaid = mysql_fetch_object($raids)) == true)
		{
			$arrRaids[$i] = $objRaid;
			$i++;
		}

		usort($arrRaids, "sortRaids");

		return $arrRaids;
	}

	/**
	 * This method returns all bosses from a specific instance.
	 *
	 * @param integer $theInstanceID
	 * @return An Array with all Bosses.
	 **/
	public function GetBosses($theInstanceID)
	{
		$arrBosses = array();
		$i = 0;

		$bosses = $this->Query("SELECT tblbosses.ID, tblbosses.BossName
								FROM tblbosses
								WHERE tblbosses.InstanceID = '" . $theInstanceID . "'
								GROUP BY tblbosses.ID ASC");

		while(($objBoss = mysql_fetch_object($bosses)) == true)
		{
			$arrBosses[$i] = $objBoss;
			$i++;
		}

		return $arrBosses;
	}

	/**
	 * This Method return the number of kills a Raid
	 * has done over all instances or one specific.
	 *
	 * @param integer $strRaidID
	 * @param integer $theInstanceID
	 * @return The number of kills.
	 **/
	public function GetNumberOfKills($strRaidID, $theInstanceID = NULL)
	{
		$arrKills = array();
		$instanceQuery = "";
		$nKills = 0;
		$i = 0;

		if($theInstanceID != NULL)
		{
			$instanceQuery = "AND tblinstances.ID = '" . $theInstanceID . "'";
		}

		$query = "SELECT COUNT(tblraids.ID) AS NumberOfKills, tblinstances.InstanceName, tblinstances.ID
					FROM tblkills, tblraids, tblinstances, tblbosses
					WHERE (tblkills.RaidID = tblraids.ID)
						AND (tblkills.BossID = tblbosses.ID)
						AND (tblbosses.InstanceID = tblinstances.ID)
						AND tblraids.ID = '" . $strRaidID . "'"
						. $instanceQuery . "
					GROUP BY tblinstances.InstanceName
					ORDER BY tblinstances.ID";

		$kills = $this->Query($query);

		while(($objKill = mysql_fetch_object($kills)) == true)
		{
			$arrKills[$i] = $objKill;
			$i++;
		}

		return $arrKills;
	}

	/**
	 * This Method returns all kills from a specific boss.
	 *
	 * @param integer $theBossID
	 * @return An array with all kills from the boss.
	 **/
	public function GetBossKills($theBossID)
	{
		$i = 0;
		$arrBossKills = array();

		$raidbosskills = $this->Query("SELECT tblkills.KillDate, tblkills.RaidID, tblkills.Comment
										FROM tblkills
										WHERE (tblkills.BossID = '" . $theBossID . "')");

		while(($objKill = mysql_fetch_object($raidbosskills)) == true)
		{
			$arrBossKills[$i] = $objKill;
			$i++;
		}

		return $arrBossKills;
	}

	/**
	 * This method returns the last 10 raids who killed a boss ordered by date.
	 *
	 * @param integer $theMaxNumberOfKills
	 * @return An array with the last 10 raids.
	 **/
	public function GetLatestKills($theMaxNumberOfKills = 10)
	{
		$arrBossKills = array();
		$i = 0;

		$result = $this->Query("SELECT tblkills.KillDate, tblkills.Comment, tblraids.ID AS RaidID, tblraids.RaidName, tblbosses.BossName
								FROM tblkills, tblraids, tblbosses
								WHERE (tblkills.BossID = tblbosses.ID)
									AND (tblkills.RaidID = tblraids.ID)
									AND (tblkills.KillDate IS NOT NULL)
								ORDER BY tblkills.KillDate DESC
								LIMIT " . $theMaxNumberOfKills);

		while(($objKill = mysql_fetch_object($result)) == true)
		{
			$arrBossKills[$i] = $objKill;
			$i++;
		}

		return $arrBossKills;
	}

	/**
	 * This method returns some information about a specific raid.
	 *
	 * @param integer $theRaidID
	 * @return An object with raidinformation.
	 **/
	public function GetRaidInfo($theRaidID)
	{
		$raid = $this->Query("SELECT tblraids.RaidName, tblraids.RaidTag, tblraids.RaidHomepage
								FROM tblraids
								WHERE tblraids.ID = '" . $theRaidID . "'");

		$objRaid = mysql_fetch_object($raid);

		return $objRaid;
	}

	public function GetUser($theUsername)
	{
		$user = $this->Query("SELECT ID, Username, Password
								FROM tbluser
								WHERE Username = '" . $theUsername . "'");

		$objUser = mysql_fetch_object($user);

		return $objUser;
	}

	public function AddRaid($theRaidname, $theRaidtag, $theRaidhomepage, $theFaction)
	{
		$query = $this->Query("INSERT INTO `tblraids` (`ID`, `RaidName`, `RaidTag`, `RaidHomepage`, `Faction`)
								VALUES (NULL, '" . $theRaidname . "', '" . $theRaidtag . "', '" . $theRaidhomepage . "', '" . $theFaction . "')");


	}
}

function sortRaids($a, $b)
{
	if ($a->NumberOfKills == $b->NumberOfKills)
	{
		return 0;
    }

	return ($a->NumberOfKills > $b->NumberOfKills) ? -1 : 1;
}

?>