<?php

class InstancePage extends BasePage
{
	private $nInstanceID;

	public function InstancePage()
	{
		parent::BasePage();

		$this->objTPL->assign("Template", "Instance");

		if(isset($_GET["i"]))
		{
			$this->nInstanceID = $_GET['i'];
		}
		else	// No InstanceID found
		{
			header("Location: index.php");
		}
	}

	public function Render()
	{
		$strInstanceName = $this->getInstanceName($this->nInstanceID);
		$arrBosses = $this->objDB->GetBosses($this->nInstanceID);	// Get all Bosses from Instance
		$arrHordeRaids = $this->objDB->GetRaids("H");		// Get all Horde Raids
		$arrAllianceRaids = $this->objDB->GetRaids("A");	// Get all Alliance Riads
		$arrHordeBossKills = array();
		$arrAllianceBossKills = array();

		// Generate the Array for Smarty
		// Array[Boss][Raid] = (KilledYesNo, KillDate)
		for($i = 0; $i < count($arrBosses); $i++)
		{
			$arrTempKills = $this->objDB->GetBossKills($arrBosses[$i]->ID);

			for($j = 0; $j < count($arrHordeRaids); $j++)
			{
				$arrHordeBossKills[$i][$j] = array(false, NULL, NULL);

				for($k = 0; $k < count($arrTempKills); $k++)
				{
					if($arrHordeRaids[$j]->ID == $arrTempKills[$k]->RaidID)
					{
						$killDate = ($arrTempKills[$k]->KillDate != NULL) ? date("j M Y", strtotime($arrTempKills[$k]->KillDate)): "";
						$arrHordeBossKills[$i][$j] = array(true, $killDate, $arrTempKills[$k]->Comment);
						break;
					}
				}
			}

			for($j = 0; $j < count($arrAllianceRaids); $j++)
			{
				$arrAllianceBossKills[$i][$j] = array(false, NULL, NULL);

				for($k = 0; $k < count($arrTempKills); $k++)
				{
					if($arrAllianceRaids[$j]->ID == $arrTempKills[$k]->RaidID)
					{
						$killDate = ($arrTempKills[$k]->KillDate != NULL) ? date("j M Y", strtotime($arrTempKills[$k]->KillDate)): "";
						$arrAllianceBossKills[$i][$j] = array(true, $killDate, $arrTempKills[$k]->Comment);
						break;
					}
				}
			}
		}

		$this->objTPL->assign("InstanceName", $strInstanceName);
		$this->objTPL->assign("HordeRaids", $arrHordeRaids);
		$this->objTPL->assign("AllianceRaids", $arrAllianceRaids);
		$this->objTPL->assign("Bosses", $arrBosses);
		$this->objTPL->assign("HordeBossKills", $arrHordeBossKills);
		$this->objTPL->assign("AllianceBossKills", $arrAllianceBossKills);
		$this->objTPL->assign("SQLQueries", $this->objDB->SQLQueries());

		$this->objTPL->display($this->strStyle . "/Header.tpl");
	}

	private function getInstanceName($theInstanceID)
	{
		$result = $this->objDB->Query("SELECT InstanceName FROM tblinstances WHERE ID = '" . $theInstanceID . "'");
		list($InstanceName) = (mysql_fetch_row($result));

		return $InstanceName;
	}
}

?>